#!/bin/bash
########################################
#    data:2021年7月2日                 #
#    blog:https://blog.hlhasd.com/     #
#                                      #
#######################################
# 后台启动方法 nohup /home/pi/xhsell/ip-mail.sh >/dev/null 2>&1 &
mail_log='/var/log/ip_mail.log'
mail_user='1327840813@qq.com' #发件人邮箱
mail_pass='#########'  #发件人密码
mail_addr='1327840813@qq.com' #收件人邮箱
fail=0
function mail_info(){
  eth0=`ifconfig eth0 | sed -n "2,2p" | awk '{print substr($2,1)}'`  
  wlan0=`ifconfig wlan0 | sed -n "2,2p" | awk '{print substr($2,1)}'`
  Public=`curl -s cip.cccurl cip.cc |grep -oP "\K([0-9]{1,3}[.]){3}[0-9]{1,3}" |awk 'NR==1'`
  str="检测到网络发生变化,新的网络信息如下:<br/>eth0:$eth0<br/>wlan0:$wlan0<br/>公网地址:$Public"
  info=`sendemail -f $mail_user -t $mail_addr -s smtp.qq.com -u '网络发生变化通知' -o message-content-type=html -o message-charset=utf8 -xu $mail_user -xp $mail_pass -m $str`
  echo $info>>$mail_log
}
while true
do
text_time=$(date "+%Y-%m-%d %H:%M:%S")
RET_CODE=`curl -I -s --connect-timeout 2 www.baidu.com -w %{http_code} | tail -n1`
if [ "x$RET_CODE" = "x200" ]; then
if [ $fail -ne 0  ];then
echo $text_time "  网络已恢复,发送邮件...">>$mail_log
mail_info
fi
sleep 20s
fail=0
echo $fail
else
sleep 3s
let fail++
if [ $fail -eq 1 ];then
echo $text_time "  网络中断,等待恢复中..." >> $mail_log
fi
echo $fail
fi
done
